/*
 * The contents of this file are subject to the terms 
 * of the Common Development and Distribution License 
 * (the License).  You may not use this file except in
 * compliance with the License.
 * 
 * You can obtain a copy of the license at 
 * https://glassfish.dev.java.net/public/CDDLv1.0.html or
 * glassfish/bootstrap/legal/CDDLv1.0.txt.
 * See the License for the specific language governing 
 * permissions and limitations under the License.
 * 
 * When distributing Covered Code, include this CDDL 
 * Header Notice in each file and include the License file 
 * at glassfish/bootstrap/legal/CDDLv1.0.txt.  
 * If applicable, add the following below the CDDL Header, 
 * with the fields enclosed by brackets [] replaced by
 * you own identifying information: 
 * "Portions Copyrighted [year] [name of copyright owner]"
 * 
 * Copyright 2006 Sun Microsystems, Inc. All rights reserved.
 */
 
/*
 * $Header: /cvs/glassfish/appserv-api/src/java/com/sun/appserv/management/util/jmx/ReadWriteAttributeFilter.java,v 1.1 2006/12/02 06:04:21 llc Exp $
 * $Revision: 1.1 $
 * $Date: 2006/12/02 06:04:21 $
 */
 

package com.sun.appserv.management.util.jmx;

import javax.management.MBeanAttributeInfo;

/**
	This class contains various filters based on read/write status of
	an Attribute.
 */
public class ReadWriteAttributeFilter implements AttributeFilter
{
	protected		ReadWriteAttributeFilter( )	{}
	
	/**
	 */
		public boolean
	filterAttribute( final MBeanAttributeInfo info )
	{
		throw new RuntimeException( "Can't get here" );
	}
	
	public static final AttributeFilter	READ_ONLY_FILTER =
		new ReadWriteAttributeFilter( )
	{
		public boolean	filterAttribute( final MBeanAttributeInfo info )
		{
			return( info.isReadable() && ! info.isWritable() );
		}
	};
		
	public static final AttributeFilter	READABLE_FILTER =
		new ReadWriteAttributeFilter( )
	{
		public boolean	filterAttribute( final MBeanAttributeInfo info )
		{
			return( info.isReadable() );
		}
	};
		
	public static final AttributeFilter	WRITE_ONLY_FILTER =
		new ReadWriteAttributeFilter()
	{
		public boolean	filterAttribute( final MBeanAttributeInfo info )
		{
			return( info.isWritable() && ! info.isReadable() );
		}
	};
		
	public static final AttributeFilter	WRITEABLE_FILTER =
		new ReadWriteAttributeFilter()
	{
		public boolean	filterAttribute( final MBeanAttributeInfo info )
		{
			return( info.isWritable() );
		}
	};
		
	public static final AttributeFilter	READ_WRITE_FILTER =
		new ReadWriteAttributeFilter()
	{
		public boolean	filterAttribute( final MBeanAttributeInfo info )
		{
			return( info.isWritable() && info.isReadable() );
		}
	};
		
	public static final AttributeFilter	ALL_FILTER =
		new ReadWriteAttributeFilter()
	{
		public boolean	filterAttribute( final MBeanAttributeInfo info )
		{
			return( true );
		}
	};
}






